{-----------------}
{arifmetika kompleksn. chisel dlq FPC-paskalq}

 type complex=record re,im:double; end;

 const i_:complex=(re:0; im:1);

 function wy(c:complex):string; var s1,s2:string[20];
 begin str(c.re:5:2,s1); str(c.im:5:2,s2); wy:=' ('+s1+' '+s2+')'; end;

 function soprqz(a:complex):complex;
 begin soprqz.re:=a.re; soprqz.im:=-a.im; end;

 function csqrt(b:complex):complex; var r,i,rr,fi,tgfi:double;
 begin
  r:=b.re; i:=b.im; rr:=sqrt(sqr(r)+sqr(i));
  if (r=0) and (i=0) then fi:=0; {uslovno}
  if (r=0) and (i>0) then fi:=pi/2;
  if (r=0) and (i<0) then fi:=3*pi/2;
  if (r<>0) then begin
   tgfi:=i/r; fi:=arctan(tgfi);
   if r<0 then fi:=fi+pi; if (i<0) and (r>0) then fi:=fi+2*pi;
  end; {eto obyesp.fi=0..2*pi};
  rr:=sqrt(rr); fi:=fi/2; r:=rr*cos(fi); i:=rr*sin(fi);
  if i<0 then begin r:=-r; i:=-i end; csqrt.re:=r; csqrt.im:=i;
 end;

 function cabs(c:complex):double; begin cabs:=sqrt(sqr(c.re)+sqr(c.im)) end;

 function arg(b:complex):double; var r,i,fi,tgfi:double;
 begin r:=b.re; i:=b.im;
  if (r=0) and (i=0) then fi:=0; {uslovno}
  if (r=0) and (i>0) then fi:=pi/2;
  if (r=0) and (i<0) then fi:=3*pi/2;
  if (r<>0) then begin
   tgfi:=i/r; fi:=arctan(tgfi);
   if r<0 then fi:=fi+pi; if (i<0) and (r>0) then fi:=fi+2*pi
  end; {eto obyesp.fi=0..2*pi}; arg:=fi
 end;

 function cmplx(x,y:double):complex;
 begin cmplx.re:=x; cmplx.im:=y; end;

 operator =(a,b:complex)c:boolean;
 begin c:=(a.re=b.re) and (a.im=b.im); end;

 operator +(a:complex; b:complex)c:complex;
 begin c.re:=a.re+b.re; c.im:=a.im+b.im; end;
 operator +(a:complex; b:double)c:complex;
 begin c.re:=a.re+b; c.im:=a.im; end;
 operator +(a:double; b:complex)c:complex;
 begin c.re:=a+b.re; c.im:=b.im; end;

 operator -(a:complex; b:complex)c:complex;
 begin c.re:=a.re-b.re; c.im:=a.im-b.im; end;
 operator -(a:complex; b:double)c:complex;
 begin c.re:=a.re-b; c.im:=a.im; end;
 operator -(a:double; b:complex)c:complex;
 begin c.re:=a-b.re; c.im:=-b.im; end;

 operator *(a:complex; b:complex)c:complex;
 begin c.re:=a.re*b.re-a.im*b.im; c.im:=a.re*b.im+b.re*a.im; end;
 operator *(a:complex; b:double)c:complex;
 begin c.re:=b*a.re; c.im:=b*a.im; end;
 operator *(a:double; b:complex)c:complex;
 begin c.re:=a*b.re; c.im:=a*b.im; end;

 function csqr(b:complex):complex;
 begin csqr:=b*b; end;

 operator /(a,b:complex)c:complex; var d:double;
 begin d:=sqr(b.re)+sqr(b.im);
  if d>0 then begin
   c.re:=(a.re*b.re+a.im*b.im)/d; c.im:=(a.im*b.re-a.re*b.im)/d
  end else begin
   c.re:=0; c.im:=0; {uslovno}
  end;
 end;
 operator /(a:complex; b:double)c:complex;
 begin c.re:=a.re/b; c.im:=a.im/b; end;

 function cexp(b:complex):complex; var c:double;
 begin c:=exp(b.re); cexp.re:=c*cos(b.im); cexp.im:=c*sin(b.im); end;

 function ccos(b:complex):complex; const i:complex=(re:0; im:1);
 begin ccos:=0.5*(cexp(i*b)+cexp(-1*i*b)); end;

 function csin(b:complex):complex; const i:complex=(re:0; im:1);
 begin csin:=-0.5*i*(cexp(i*b)-cexp(-1*i*b)); end;

 function c_tg(b:complex):complex;
 begin c_tg:=csin(b)/ccos(b); end;

 {--------------------}
